#include <stdlib.h>

#include <wqueue.h>

typedef struct {
    work_f func;
    void *data;
} work_desc_t;


int wqueue_insert(wqueue_t *wq, unsigned int pri, work_f func, void *data) {
    work_desc_t *wd;

    wd = malloc(sizeof(work_desc_t));
    if (wd == NULL) {
        return -1;
    }

    wd->func = func;
    wd->data = data;

    if (pqueue_insert((pqueue_t *)wq, pri, wd) == -1) {
        free(wd);
        return -1;
    }

    return 0;
}

int wqueue_run(wqueue_t *wq) {
    work_desc_t *wd;

    wd = pqueue_remove(wq);

    if (wd == NULL) {
        return 0;
    }

    wd->func(wd->data);
    free(wd);
    return 1;
}
